var numberOfparts = 9;
var array = [];
var counter = 0

function initPuzzle(){
	var puzzle = document.createElement("div");
	puzzle.setAttribute("id", "puzzle");

	var counter = document.createElement("div");
	counter.textContent = 0;
	counter.setAttribute("id", "counter");

	puzzle.appendChild( counter );
	document.body.appendChild( puzzle );

	shuffleArray()

	//
	// initilizes parts with images and sets data and ids
	//
	for (i = 0; i < array.length; i++) {
    var part_id = array[i];

		var partCont = document.createElement("div");
		partCont.setAttribute("class", "part-cont");
		partCont.setAttribute("ondrop", "drop(event)");
		partCont.setAttribute("ondragover", "dragOver(event)");

    var part = document.createElement("img");
		part.setAttribute("class", "part");
		part.setAttribute("draggable", "true");
		part.setAttribute("ondragstart", "drag(event)");

    part.setAttribute("id", "part_" + part_id);
    part.setAttribute('data', part_id);
    part.setAttribute("src", "parts/part_" + part_id + ".jpeg");

    partCont.appendChild( part );
    puzzle.appendChild( partCont );
	}
}

//
// fills and shuffles array
//
function shuffleArray(){
	function randOrd(){
		return (Math.round(Math.random())-0.5); 
	}

	for (i = 1; i<=numberOfparts; i++)
	{
    array.push(i);
	}

	array.sort( randOrd );
}

function dragOver(event){
	event.preventDefault();
}

function drag(event){
	event.dataTransfer.setData("source_id", event.target.id);
}

function drop(event){
	event.preventDefault();

	//
	// because of event bubbling the necessary elemts have to be established before the change
	//
	var source_id = event.dataTransfer.getData("source_id");
	var source = document.getElementById( source_id );
	var target = document.getElementById( event.target.id );
	var targetParent = target.parentNode;

	source.parentNode.appendChild( target );
	targetParent.appendChild( source );

	//
	// move counter is only incremented when a real drag move happened
	//
	if (source != target ) {
		counter += 1;
		document.getElementById("counter").textContent = counter;	
	}

	if ( isGameOver() ) {
		document.getElementById("counter").textContent = "Game Over";
		counter = 0;
	}
}

function isGameOver() {
	var parts = document.getElementsByClassName("part");
	over = true

	//
	// uses the data attribut to check if parts are on the right position
	//
	for (i = 0; i < parts.length; i++) {
		over = over && ( parseInt( parts[i].getAttribute("data") ) == i + 1 );
	}

	return over
}

document.addEventListener('DOMContentLoaded', initPuzzle, false);
